let execSync = require('child_process').execSync;
let fs = require('fs');
let path = require('path');

function installDependecies() {
  console.log('Adding dev dependencies for the project...');

  let dependenciesJsonPath = path.resolve('dependencies.json');
  let dependencies = JSON.parse(fs.readFileSync(dependenciesJsonPath));

  for (let depName in dependencies) {
    let depVersion = dependencies[depName];
    let depToInstall = depName + '@' + depVersion;
    console.log('Adding ' + depToInstall + '...');
    execSync(`yarn add ${depToInstall} -D`, { stdio: 'inherit' });
  }
}

function installDevDependencies() {
  console.log('Adding dev dependencies for the project...');

  let devDependenciesJsonPath = path.resolve('devDependencies.json');
  let devDependencies = JSON.parse(fs.readFileSync(devDependenciesJsonPath));

  for (let depName in devDependencies) {
    let depVersion = devDependencies[depName];
    let depToInstall = depName + '@' + depVersion;
    console.log('Adding ' + depToInstall + '...');
    execSync(`yarn add ${depToInstall} -D`, { stdio: 'inherit' });
  }
}

function cleanup() {
  let devDependenciesJsonPath = path.resolve('devDependencies.json');
  let dependenciesPath = path.resolve('dependencies.json');
  fs.unlink(devDependenciesJsonPath);
  execSync(`rm -rf ${devDependenciesJsonPath} ${dependenciesPath}`);
}

function postTemplateInit() {
  installDependecies();
  installDevDependencies();
  cleanup();
}

postTemplateInit();
